// C Header File
// Created 8/24/2002; 12:45:49 PM


void SetGhostsToRunAway(void);

//=============================================================================
// generate dots for all map areas of type '0'
//=============================================================================



short DotGenerateFromMap(FATCONFIG *fc)
{
short x,y;
short count=0;

for(y=0;y<gamedata.ysize;y++)
{
	for(x=0;x<gamedata.xsize;x++)
	{
		if(!fc->map_data[y*gamedata.xsize + x]) count++;
		else if(fc->map_data[y*gamedata.xsize + x]==-3) count++;
	}
}

dotspr = (FATSPRITE*)(allspr + gamedata.cfg.ghost_count); //Dots are second in the sprites

FATSPRITE *cursprite = (FATSPRITE*)dotspr;
for(x=0;x<MAX_ONSCREEN_DOTS;)
{
    //-------------------------------------------------------------------------
    // initialize sprite structure and setup its fields
    //-------------------------------------------------------------------------
    
    FAT_InitSprite(cursprite);
    cursprite->drawmode    = THE_DOT_MODE;
    cursprite->nr_textures = 1;
    cursprite->textures    = (TEXCONFIG*) sprite_tex; //the dot sprite
    cursprite->orientation = 0;
    cursprite->xpos        = 96;
    cursprite->ypos        = 96;
    x++;
    if(x<(MAX_ONSCREEN_DOTS)) ++cursprite;
}

   return count;
}



short CheckDotPresent(FATCONFIG *fc)
{
short count = 0;
short x = (fc->cam_xpos>>6);
short y = (fc->cam_ypos>>6);
short xdelta = 0;
short ydelta = 0;

FATSPRITE *current = dotspr;


switch(fc->cam_orientation)
{
case 504 ... 576: //East
xdelta = 1;
break;
case 0 ... 71:
xdelta = 1;
break;

case 72 ... 215: //South
ydelta = 1;
break;

case 216 ... 359: //West
xdelta = -1;
break;

case 360 ... 503: //North
ydelta = -1;
break;
}

while(1)
{

	if(fc->map_data[y*gamedata.xsize + x]>0) //We're at a wall
	break;
	
	if(fc->map_data[y*gamedata.xsize + x]==0) //We're at a dot
	{
    current->xpos        = (x*64)+32;
    current->ypos        = (y*64)+32;
    current->drawmode = THE_DOT_MODE;
    current->textures    = sprite_tex; //the dot sprite
    ++count;
	if(count==MAX_ONSCREEN_DOTS) {break;}
    ++current;
	}
	
	else if(fc->map_data[y*gamedata.xsize + x]==-3) //We're at a SUPERdot
	{
    current->xpos        = (x*64)+32;
    current->ypos        = (y*64)+32;
    current->drawmode = THE_DOT_MODE;
    current->textures    = sprite_tex+1; //the superdot sprite
    ++count;
	if(count==MAX_ONSCREEN_DOTS) {break;}
    ++current;
	}
		
x += xdelta;
y += ydelta;

}
return count;

} 

void CheckDotEaten(FATCONFIG *fc)
{

short count=0;
char buffer[20];
short x,y;
FATSPRITE *cursprite = dotspr;
  for(count=0;count < (fc->nr_sprites-gamedata.ghosts.count);)
  {

x=(cursprite->xpos)>>6;
y=(cursprite->ypos)>>6;
if(((fc->cam_xpos>>6)==x)&&
((fc->cam_ypos>>6)==y))
{
if(fc->map_data[y*gamedata.xsize + x]==-3) //superdot


SetGhostsToRunAway();


fc->map_data[y*gamedata.xsize + x] = -1;
gamedata.dot.left--;
sprintf(buffer,"Left: %i/%i    ",gamedata.dot.left,gamedata.dot.count);
DrawGrayStrExt(97+display_offsetx,22+display_offsety,buffer,F_4x6,A_REVERSE);

}
count++;
++cursprite;
  }              //end FOR loop


if(gamedata.dot.left==0) 
{
	PlayerGoToNextLevel(fc);
}

}  
